*! version 1.0.0   06-15-1998   DEM

program define array

   local s1 $S_1
   local s2 $S_2
   
    parse "`*'", parse("{}")
    local aname `1'
    local leftOK = index("`2'", "{")
    local rightOK = index("`4'", "}")
    if !`leftOK' | !`rightOK' {
        di in r "invalid syntax, array dimension(s) misspecified"
        exit 198
    }
    local dims  `3'
    local avars `5'
    
    parse "`dims'", parse(", ")
    local ndims : word count `dims'
    if `ndims' == 2*int(`ndims'/2) {
        di in r "invalid syntax, array dimension(s) misspecified"
        exit 198
    } 
    local nvars 1
    while "`1'" != "" {
        if "`1'" != "," {
            local dim = int(`1') 
            if `dim' <= 0 {
               di in r "array bound must be positive integer"
               exit 7
            }
            local nvars = `nvars' * `dim'
            local bounds `bounds' `dim'
        }
        macro shift
    }
    
    vlist `avars'
    local vn $S_1
    local nv $S_2
    global S_1 `s1'
    global S_2 `s2'
    if `nvars' > `nv' {
        display in r "too few variables defined for the dimension(s) specified for the array `aname'"
        exit 198
    }
    else if `nvars' < `nv' {
        display in r "too many variables defined for the dimension(s) specified for the array `aname'"
        exit 198
    }
    global `aname' {`bounds'}`vn'
    
end

program define vsplit
   confirm new variable `*'
   local digit = substr("`*'", -1, 1)
   local name = substr("`*'",1,length("`*'")-1)
   if !index("0123456789","`digit'") { error 198 }
   while index("0123456789", "`digit'") {
      local numpart = "`digit'" + "`numpart'"
      local digit = substr("`name'", -1, 1)
      local name = substr("`name'", 1, length("`name'")-1)
   }
   global S_1 = "`name'" + "`digit'"
   global S_2 `numpart'
end

program define vlist
   parse "`*'", parse("*-")
   if "`2'" != "*" & "`2'" != "-" {
      local varlist "optional new"
      capture parse "`*'"
      if _rc {
         local varlist "optional"
         parse "`*'"
      }
      global S_1 `varlist'
      global S_2 : word count `varlist'
      exit 0
   }
   
   /* got a variable list */
   
   else if "`2'" == "*" {
      unabbrev `*'
      exit 0
   }
   
   local varlist "optional new"
   capture parse "`*'"
   if !_rc { 
      global S_1 `varlist'
      global S_2 : word count `varlist'
      exit 0
   }
   else if _rc == 110 {
      unabbrev `*'
      exit 0
   }
   capture unabbrev `*'
   if _rc {
      local varlist "optional new"
      capture parse "`*'"
      if _rc == 198 {
         parse "`*'", parse(" -")
         while "`1'" != "" {
            if "`2'" == "-" {
               vsplit `1'
               local vname $S_1
               local i $S_2
               vsplit `3'
               if "`vname'" != "$S_1" { error 198 }
               if `i' > $S_2 { error 198 }
               while `i' <= $S_2 {
                  local vars `vars' `vname'`i'
                  local i = `i' + 1
               }
               macro shift
               macro shift
               macro shift
            }
            else local vars `vars' `1'
         }
         local varlist "optional new"
         parse "`vars'"
         global S_1 `varlist'
         global S_2 : word count `varlist'
      }
      else if _rc { parse "`*'" }
      else {
         global S_1 `varlist'
         global S_2 : word count `varlist'
      }
   }
end

